﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Nutshell.ThreadWorkerPool
{
    public interface IThreadWorkerPool
    {
        string Name { get; }

        int TotalThreadWorkerCount { get; }

        int IdleThreadWorkerCount { get; }

        ThreadWorkerPoolSettings Settings { get; }

        IThreadWorker Take();

        bool TryTake(out IThreadWorker threadWorker);

        bool TryTake(int timeout, out IThreadWorker threadWorker);
    }

    public interface IThreadWorkerPool<T>
    {
        string Name { get; }

        int TotalThreadWorkerCount { get; }

        int IdleThreadWorkerCount { get; }

        ThreadWorkerPoolSettings Settings { get; }

        IThreadWorker<T> Take();

        bool TryTake(out IThreadWorker<T> threadWorker);

        bool TryTake(int timeout, out IThreadWorker<T> threadWorker);

    }
}
