﻿using System.Threading;

namespace Nutshell.ThreadWorkerPool
{
    public struct ThreadWorkerPoolSettings
    {
        private int _minThreadWorkerCount;
        private int _maxThreadWorkerCount;
        private bool _isBackground;
        private int _idleTime;
        private ThreadPriority _priority;

        public ThreadWorkerPoolSettings(int minThreadWorkerCount, int maxThreadWorkerCount, bool isBackground, int idleTime, ThreadPriority priority)
        {
            _minThreadWorkerCount = minThreadWorkerCount;
            _maxThreadWorkerCount = maxThreadWorkerCount;
            _isBackground = isBackground;
            _idleTime = idleTime;
            _priority = priority;
        }

        public static ThreadWorkerPoolSettings Default
        {
            get
            {
                return new ThreadWorkerPoolSettings(10, 100, false, 60 * 1000 * 10, ThreadPriority.Normal);
            }
        }

        public int MinThreadWorkerCount
        {
            get { return _minThreadWorkerCount; }
            set { _minThreadWorkerCount = value; }
        }

        public int MaxThreadWorkerCount
        {
            get { return _maxThreadWorkerCount; }
            set { _maxThreadWorkerCount = value; }
        }

        public bool IsBackground
        {
            get { return _isBackground; }
            set { _isBackground = value; }
        }

        public int IdleTime
        {
            get { return _idleTime; }
            set { _idleTime = value; }
        }

        public ThreadPriority Priority
        {
            get { return _priority; }
            set { _priority = value; }
        }
    }
}
